<?php
    /*Feito por Victor Rangel
    Produto Odhen*/
namespace Teknisa\MAN\Controllers;

use Teknisa\MAN\Services\MarcasFabricanteService;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;

class MarcasFabricante extends \Teknisa\MAN\Controllers\TeknisaCrud {
    
    protected $dataSourceNameArray = array (
        'marcas_cadastradas' => 'ger10900_cadastroFabricante_marcas',
        'marcas'             => 'ger10900_cadastroFabricante_selectMarcas'
    );
    protected $parameterBagColumnsArray = array (
        'marcas_cadastradas' =>  array('NRORG', 'CDFABRICANTE'),
        'marcas' =>  array('NRORG')
    );
    
    public function __construct ($crudService, $parameterBag, Manager $dataSourceManager, MarcasFabricanteService $marcasFabricanteService) {
        $this->crudService              = $crudService;
        $this->parameterBag             = $parameterBag;
        $this->dataSourceManager        = $dataSourceManager;
        $this->marcasFabricanteService  = $marcasFabricanteService;
    }
    
    ///find's
    public function FindMarcasCadastradas(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = $this->dataSourceNameArray['marcas_cadastradas'];
        $this->parameterBagColumns = $this->parameterBagColumnsArray['marcas_cadastradas'];
        parent::find($request, $response);
    }
    
    public function FindMarcas(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = $this->dataSourceNameArray['marcas'];
        $this->parameterBagColumns = $this->parameterBagColumnsArray['marcas'];
        parent::find($request, $response);
    }
    
    ///save's
    public function SaveMarca(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        
        $params = array(
            ':NRORG'        => $row['NRORG'],
            ':CDMARCA'      => $row['CDMARCA'],
            ':CDFABRICANTE' => $row['CDFABRICANTE'],
            ':DATA'         => $row['DATA'],
            ':CDOPERADOR'   => $row['CDOPERADOR'],
        );
        
        $this->marcasFabricanteService->cadastraMarca($params);
    }
    
    //delete's
    public function DeleteMarca(DTO\Request\Row $request, DTO\Response $response){
        $this->dataSourceName = $this->dataSourceNameArray['marcas_cadastradas'];
        parent::delete($request,$response);
    }
}