<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class RelProdOperService {

	public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }
    
    public function findProdOpe($CDFILIAL, $DTENTRVENDAINI, $DTENTRVENDAFIN, $CDCAIXA, $NRORG, $TCDCAIXA, $CDOPERADOR, $TCDOPERADOR, $MODALIDADE) {
        $params = array(
            ":CDCAIXA"        => $CDCAIXA,
            ":TCDCAIXA"       => $TCDCAIXA,
            ":CDFILIAL"       => $CDFILIAL,
            ":CDOPERADOR"     => $CDOPERADOR,
            ":TCDOPERADOR"    => $TCDOPERADOR,
            ":DTENTRVENDAINI" => $DTENTRVENDAINI,
            ":DTENTRVENDAFIN" => $DTENTRVENDAFIN,
            ":MODALIDADE"     => $MODALIDADE,
            ":NRORG"          => $NRORG
 	    );
 		return $this->entityManager->getConnection()->fetchAll(self::GET_PRODUTIVIDADE_OPERADOR, $params);
    }

    const GET_PRODUTIVIDADE_OPERADOR = "
      SELECT FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, FILOCAVE.CDCAIXA, FILOCAVE.NMCAIXA, FILOCAVE.CDOPERADOR, FILOCAVE.NMOPERADOR, FILOCAVE.MODALIDADE AS LABELMODALIDADE,
             I.CDPRODUTO, P.NMPRODUTO, P.CDARVPROD, I.VRUNITVEND, FILOCAVE.CDFILIAL||' - '||FILOCAVE.NMFILIAL AS LABELFILIAL, FILOCAVE.CDCAIXA||' - '||FILOCAVE.NMCAIXA AS LABELCAIXA, 
             FILOCAVE.CDOPERADOR||' - '||FILOCAVE.NMOPERADOR AS LABELOPERADOR, 
             SUM(TRUNC(I.QTPRODVEND * ( NVL(I.VRUNITVEND, 0) + NVL(I.VRUNITVENDCL,0)) - NVL(I.VRDESITVEND, 0) + NVL(I.VRACRITVEND, 0), 2)) AS VRTOTVEND,
             SUM(I.QTPRODVEND) AS QTPRODVEND, SUM(I.VRDESITVEND) AS VRDESITVEND, SUM(I.VRACRITVEND) AS VRACRITVEND
        FROM ITEMVENDA I
        JOIN PRODUTO P 
          ON I.CDPRODUTO = P.CDPRODUTO 
         AND I.NRORG = P.NRORG
        JOIN (SELECT V.IDSITUVENDA, V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.NMCAIXA, FILOCA.CDLOJA, FILOCA.NMLOJA, FILOCA.CDFILIAL,
                     V.DTVENDA, V.DTENTRVENDA, FILOCA.NMFILIAL, NVL(V.VRREPIQUEVENDA, 0) AS VRREPIQUEVENDA,
                     FILOCA.NRORG, V.CDOPERADOR, O.NMOPERADOR, CASE SUBSTR(V.IDORIGEMVENDA, 0, 3)
                                       WHEN 'DLV' THEN 'DELIVERY'
                                       WHEN 'MES' THEN 'MESA'
                                       WHEN 'BAL' THEN (CASE SUBSTR(V.IDORIGEMVENDA, 5, 7) WHEN 'AUT' THEN 'TERMINAL DE AUTO-ATENDIMENTO' ELSE 'BALCAO' END) 
                                       WHEN 'TAA' THEN 'TERMINAL DE AUTO-ATENDIMENTO'
                                       WHEN 'CMD' THEN 'COMANDA'
                                       WHEN 'AJU' THEN 'OUTROS'
                                       ELSE 'OUTROS'
                                     END AS MODALIDADE
                FROM VENDA V
                JOIN (SELECT C.CDCAIXA, C.NMCAIXA, FILO.CDLOJA, FILO.NMLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.NRORG
                        FROM CAIXA C
                        JOIN (SELECT L.CDLOJA, L.NMLOJA, FI.CDFILIAL, FI.NMFILIAL, FI.NRORG, L.CDPRODTAXASERV
                                FROM LOJA L
                                JOIN (SELECT F.CDFILIAL, F.NMFILIAL, F.NRORG
                                        FROM FILIAL F
                                       WHERE INSTR(:CDFILIAL, F.CDFILIAL) > 0 
                                         AND F.NRORG =:NRORG 
                                     ) FI
                                  ON L.CDFILIAL = FI.CDFILIAL
                                 AND L.NRORG = FI.NRORG
                             ) FILO 
                          ON C.CDFILIAL = FILO.CDFILIAL 
                         AND C.CDLOJA = FILO.CDLOJA
                         AND C.NRORG = FILO.NRORG
                       WHERE ((INSTR(:CDCAIXA, FILO.CDFILIAL||C.CDCAIXA) >0 ) OR ( :TCDCAIXA = 'T' ) )
                     ) FILOCA 
                  ON V.CDCAIXA = FILOCA.CDCAIXA
                 AND V.CDLOJA = FILOCA.CDLOJA
                 AND V.CDFILIAL = FILOCA.CDFILIAL
                 AND V.NRORG = FILOCA.NRORG
               JOIN OPERADOR O
                 ON V.CDOPERADOR = O.CDOPERADOR
                AND V.NRORG = O.NRORG
              WHERE V.IDSITUVENDA = 'O' 
                AND (INSTR(:MODALIDADE, SUBSTR(V.IDORIGEMVENDA, 0, 3) ) > 0 OR INSTR(:MODALIDADE, SUBSTR(V.IDORIGEMVENDA, 5, 7) ) > 0)
                AND V.DTENTRVENDA BETWEEN :DTENTRVENDAINI AND :DTENTRVENDAFIN
                AND ((INSTR(:CDOPERADOR, V.CDOPERADOR) > 0 ) OR ( :TCDOPERADOR = 'T' ) )
           ) FILOCAVE
        ON I.CDFILIAL = FILOCAVE.CDFILIAL
       AND I.CDCAIXA = FILOCAVE.CDCAIXA
       AND I.NRSEQVENDA = FILOCAVE.NRSEQVENDA
       AND I.NRORG = FILOCAVE.NRORG
      GROUP BY FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, FILOCAVE.CDCAIXA, FILOCAVE.NMCAIXA, FILOCAVE.CDOPERADOR, FILOCAVE.NMOPERADOR,
               I.CDPRODUTO, P.NMPRODUTO, P.CDARVPROD, I.VRUNITVEND, FILOCAVE.MODALIDADE
      ORDER BY FILOCAVE.CDFILIAL, FILOCAVE.CDCAIXA, FILOCAVE.CDOPERADOR, I.CDPRODUTO
    ";
}